/* Sistemas Integrados TEKNISA

Nome: 8680_SUPTRGS.sql

Descrio:
Trigger para incluso de todos os fornecedores na 
tabela REFOREG para a regio que estiver sendo inserida.

Com essa trigger, ao incluir uma regio, automaticamente o sistema ir 
considerar que nenhum fornecedor atende  mesma.

Criao:
04/03/2004 Ederson Melquades da Cunha
*/

IF EXISTS (SELECT
              NAME
           FROM
              SYSOBJECTS
           WHERE
              NAME = 'GRAVA_REFOREG_REGIAO' AND
              TYPE = 'TR')
   DROP TRIGGER GRAVA_REFOREG_REGIAO
GO

CREATE TRIGGER GRAVA_REFOREG_REGIAO
ON REGIAO
FOR INSERT

AS

DECLARE @V_NEW_CDREGIAO VARCHAR(03);

BEGIN
   DECLARE C_INSERTED CURSOR FOR
      SELECT 
         CDREGIAO
      FROM 
         INSERTED;

   OPEN C_INSERTED;

   FETCH NEXT FROM C_INSERTED INTO @V_NEW_CDREGIAO;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      INSERT INTO REFOREG
         (CDREGIAO, 
          CDFORNECED)
      (SELECT 
          @V_NEW_CDREGIAO, 
          CDFORNECED
       FROM 
          FORNECEDOR);
      FETCH NEXT FROM C_INSERTED INTO @V_NEW_CDREGIAO;
   END;

   CLOSE C_INSERTED;
   DEALLOCATE C_INSERTED;
END;
GO